package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AlipayTemp;
import com.izouma.awesomeadmin.service.AlipayTempService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/alipayTemp")
public class AlipayTempController {

    @Autowired
    private AlipayTempService alipayTempService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AlipayTemp record) {
        List<AlipayTemp> pp = alipayTempService.getAlipayTempList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAlipayTemp", method = RequestMethod.GET)
    @ResponseBody
    public Result getAlipayTemp(@RequestParam(required = false, value = "id") String id) {
        AlipayTemp data = alipayTempService.getAlipayTempById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AlipayTemp record) {
        AlipayTemp data = alipayTempService.getAlipayTemp(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AlipayTemp record) {
        Map<String, Object> result = new HashMap<>();

        List<AlipayTemp> pp =alipayTempService.getAlipayTempByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AlipayTemp record) {
        boolean num = alipayTempService.createAlipayTemp(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAlipayTemp(AlipayTemp record) {
        boolean num = alipayTempService.updateAlipayTemp(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAlipayTemp(@RequestParam(required = true, value = "id") String id) {

        boolean num = alipayTempService.deleteAlipayTemp(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AlipayTemp record) throws Exception {

    List<AlipayTemp> alipayTemps = alipayTempService.getAlipayTempList(record);


        String sheetName = "alipay_temp";
        String titleName = "支付宝支付记录数据表";
        String fileName = "支付宝支付记录表";
        int columnNumber = 16;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "订单" ,   "状态" ,   "金额" ,   "订单码" ,   "退款码" ,   "退款数" ,   "类型" ,   "余额" ,   "积分" ,   "现金"  };
        String[][] dataList = new String[alipayTemps.size()][16];

        for (int i = 0; i < alipayTemps.size(); i++) {

                        dataList[i][0] = String.valueOf(alipayTemps.get(i).getId());
                        dataList[i][1] = String.valueOf(alipayTemps.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(alipayTemps.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(alipayTemps.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(alipayTemps.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(alipayTemps.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(alipayTemps.get(i).getOrderId());
                        dataList[i][7] = String.valueOf(alipayTemps.get(i).getTradeStatus());
                        dataList[i][8] = String.valueOf(alipayTemps.get(i).getTotalAmount());
                        dataList[i][9] = String.valueOf(alipayTemps.get(i).getOutTradeNo());
                        dataList[i][10] = String.valueOf(alipayTemps.get(i).getRefundNo());
                        dataList[i][11] = String.valueOf(alipayTemps.get(i).getRefundAmount());
                        dataList[i][12] = String.valueOf(alipayTemps.get(i).getTypeFlag());
                        dataList[i][13] = String.valueOf(alipayTemps.get(i).getCoin());
                        dataList[i][14] = String.valueOf(alipayTemps.get(i).getPoint());
                        dataList[i][15] = String.valueOf(alipayTemps.get(i).getCash());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

